

#include "stdafx.h"
#include "ScrollStatic.h"
#include "resource.h"
//-----------------------------------------------------------------------------
#define I_CLR_BLK	RGB(0,0,0)
#define I_CLR_RED	RGB(255,0,0)
#define I_CLR_BLU	RGB(0,0,255)
#define I_CLR_WHT	RGB(255,255,255)
//-----------------------------------------------------------------------------
#define I_SCR_PIX	1 
#define I_MSG_GAP	15 
//-----------------------------------------------------------------------------
#define I_EVT_TXT_SCR	(WM_USER+1001)
//-----------------------------------------------------------------------------
CScrollStatic::CScrollStatic()
{	
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	m_pClientDC = NULL;
	m_nOverPreFrmIdx = -1;

	m_bStaticMouseOver = FALSE;

	// Ʈ ʱȭ
	if (m_TxtFrmList.empty() == false)
	{
		for (TXTFRMLIST_ITER iter = m_TxtFrmList.begin(); iter != m_TxtFrmList.end(); iter++)
		{
			if ((*iter) != NULL)
			{
				delete (*iter);
				(*iter) = NULL;
			}
		}
		m_TxtFrmList.clear();
	}	
	if (m_ScrTxtList.empty() == false)
		m_ScrTxtList.clear();

	// ũ  ÷ 
	m_clrForeTxt = I_CLR_BLK;
	m_clrOverTxt = I_CLR_BLU;
	m_clrBackGround = I_CLR_WHT;

	//  ȣ  ʱȭ
	m_bMouseOverTxt = FALSE;


	m_nTxtFrameIdx = -1;
	m_bMsgDispFin = TRUE;

	m_bTimerOn = FALSE;

	// ũ 
	GetScrollCfg();

	//-----------------------------------------------------------------------------
	// by cscho
	// ؽƮ   ڿ
	m_strPrefix = _T("");
	m_szPrefix = CSize(0, 0);

	m_strPrevArrow = _T(" ");
	m_strNextArrow = _T(" ");
	m_szPrevArrow = CSize(0, 0);
	m_szNextArrow = CSize(0, 0);

	//  ؽƮ ǥ
	m_bMultiText = FALSE;
	m_nCurMultiIndex = 0;

	m_bHoverPrevArrow = FALSE;
	m_bHoverNextArrow = FALSE;

	m_nScrTxtIdxFirst = -1;

	m_rtPrevArrow.SetRectEmpty();
	m_rtNextArrow.SetRectEmpty();
	m_bPrevArrowExist = FALSE;
	m_bNextArrowExist = FALSE;
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	// by cscho
	//     
	m_nOverTxtFrmIdx = -1;
	m_nOverPreFrmIdx = -1;

	m_bTracking = FALSE;
	//-----------------------------------------------------------------------------
}
//-----------------------------------------------------------------------------
CScrollStatic::~CScrollStatic()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	if (m_pClientDC)
	{
		delete m_pClientDC;
		m_pClientDC = NULL;
	}

	DelTxtFrm(FALSE);	
}
//-----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CScrollStatic, CStatic)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//-----------------------------------------------------------------------------
	// by cscho
	//     
	ON_WM_SETCURSOR()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	//-----------------------------------------------------------------------------
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
void CScrollStatic::GetScrollCfg()
{	

	m_nHowScrollType = 0;
	m_nScrollTimer = 3000;	
	//m_nHowScrollType = 1;
	//m_nScrollTimer = 50;	
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::AddTxtFrm(CString strScrolTxt, CString strLinkId, int nDspDiv)
{	
	// ű ؽƮ  
	CTxtFrm* TxtFrmNew = new CTxtFrm(strScrolTxt, strLinkId, nDspDiv);

	if (!TxtFrmNew)
		return FALSE;

	// ؽƮ  Ʈ ߰	
	m_TxtFrmList.push_back(TxtFrmNew);
	TxtFrmNew = NULL;

	return TRUE;
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::BeginScrolling(CWnd* pOwnWnd, BOOL bReScrolling)
{
	// [ؽƮ  Ʈ] ó ڷ  
	if (!m_TxtFrmList.size())
		return FALSE;

	// ũ 
	m_bMsgDispFin = FALSE;

	// ޽ ó 
	m_pOwnWnd = pOwnWnd;

	//  ũ Ÿ̸ 
	SetTimerEvent(FALSE);

	// ũѸ ̸
	if (bReScrolling == TRUE)
	{
		//  ũ  [ؽƮ  ε Ʈ] ʱȭ		
		m_ScrTxtList.clear();

		//-----------------------------------------------------------------------------
		// by cscho
		if (!m_bMultiText)
			m_nTxtFrameIdx = 0;
		//-----------------------------------------------------------------------------

		// ũ  [ù° ؽƮ  ε] 
		if (m_nHowScrollType)
			m_ScrTxtList.push_back(0);		

		// ؽƮ ũ  ʱȭ
		InitScrFrame();

		//  ũ ؽƮ ȿȭ
		Invalidate();
	}

	// Ÿ̸ ̺Ʈ 
	SetTimerEvent(TRUE);

	return TRUE;
}
//-----------------------------------------------------------------------------
void CScrollStatic::InitScrFrame(void)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	// Ŭ̾Ʈ ۾ 
	if (m_pClientDC == NULL)
		m_pClientDC = new CClientDC(this);
	else
	{
		delete m_pClientDC;
		m_pClientDC = NULL;
		m_pClientDC = new CClientDC(this);
	}

	if (NULL == m_pClientDC)
	{
		return;
	}

	// ־  Ŭ
	SetClippingRegion(m_pClientDC);

	// ׶ 
	m_pClientDC->SetBkMode(OPAQUE);

	//   Static Ʈ  ġ
	m_pClientDC->SetBkColor(m_clrBackGround);

	//  Ʈ 
	CFont* pOldFont = m_pClientDC->SelectObject(&m_fntScrTxt);

	//-----------------------------------------------------------------------------
	// by cscho
	// ؽƮ   ڿ
	CString strPrefix = _T("");
	if (!m_strPrefix.IsEmpty())
		strPrefix.Format(_T("[%s] "), m_strPrefix);
	m_szPrefix = m_pClientDC->GetTextExtent(strPrefix);

	m_szPrevArrow = m_pClientDC->GetTextExtent(m_strPrevArrow);
	m_szNextArrow = m_pClientDC->GetTextExtent(m_strNextArrow);
	//-----------------------------------------------------------------------------

	if (m_TxtFrmList.empty() == false)
	{
		TXTFRMLIST_ITER iter = m_TxtFrmList.begin();
		for (; iter != m_TxtFrmList.end(); iter++)
		{
			// ؽƮ 
			CTxtFrm* pTxtFrm = (CTxtFrm*)(*iter);
			// x ɼ ʱȭ
			if (pTxtFrm)
			{
				if(pTxtFrm->m_xOffSetList.empty() == false)
					pTxtFrm->m_xOffSetList.clear();

				//  DC ׷ ؽƮ ũ
				pTxtFrm->m_sizeTxt = m_pClientDC->GetTextExtent(pTxtFrm->m_strScrolTxt);
			}
		}

		m_pClientDC->SelectObject(pOldFont);

		// ũ 
		if (m_nHowScrollType)
		{
			//  
			if(m_TxtFrmList.empty() == false)
			{
				TXTFRMLIST_ITER iter = m_TxtFrmList.begin();
				CTxtFrm* pTxtFrm = (CTxtFrm*)(*iter);
				if (pTxtFrm)
				{
					pTxtFrm->m_xOffSetList.push_back(m_rectScrolArea.right);
				}				
				//((CTxtFrm*)m_TxtFrmList[0])->m_xOffSetList.push_back(m_rectScrolArea.right);
			}
		}
		else
		{
			//  
			if (m_TxtFrmList.empty() == false)
			{
				TXTFRMLIST_ITER iter = m_TxtFrmList.begin();
				//-----------------------------------------------------------------------------
				// by cscho
				//  ؽƮ ǥ
				if (m_bMultiText)
				{
					m_bPrevArrowExist = ExistPrevTxtFrm();

					CSize szPrevArrow = CSize(0, 0);
					if (m_bPrevArrowExist)
						szPrevArrow = m_szPrevArrow;

					int nNewPos = m_rectScrolArea.left + 3 + szPrevArrow.cx;

					TXTFRMLIST_ITER iter = m_TxtFrmList.begin();
					for(; iter != m_TxtFrmList.end(); iter++)
					{
						m_nTxtFrameIdx++;

						CTxtFrm* pTxtFrm = (CTxtFrm*)(*iter);
						if (pTxtFrm)
						{
							pTxtFrm->m_xOffSetList.push_back(nNewPos);
							if (nNewPos < m_rectScrolArea.right)
								m_ScrTxtList.push_back(m_nTxtFrameIdx);

							if (m_ScrTxtList.size() == 1)
								m_nScrTxtIdxFirst = m_nTxtFrameIdx;

							nNewPos = nNewPos + pTxtFrm->m_sizeTxt.cx + I_MSG_GAP;
						}
					}

					m_bNextArrowExist = ExistNextTxtFrm();
					if (m_bNextArrowExist)
					{
						m_rtNextArrow.SetRect(m_rectScrolArea.right - m_szNextArrow.cx,
							m_rectScrolArea.top,
							m_rectScrolArea.right - 1,
							m_rectScrolArea.bottom);
					}
				}
				//-----------------------------------------------------------------------------
				else
				{
					CTxtFrm* pTxtFrm = (CTxtFrm*)(*iter);
					if (pTxtFrm)
					{
						pTxtFrm->m_xOffSetList.push_back(m_rectScrolArea.left + 3);
					}				
					//((CTxtFrm*)m_TxtFrmList[0])->m_xOffSetList.push_back(m_rectScrolArea.left + 3);
				}
			}
		}
	}	
}
//-----------------------------------------------------------------------------
void CScrollStatic::CreateTxtFont(void)
{
	//  Ʈ	
	CFont* curWinFont = &g_ftDefault8PT;

	// LOGFONT ü	
	LOGFONT logFont;

	//  Ʈ αƮ
	curWinFont->GetLogFont(&logFont);

	// Ʈ Ӽ
	logFont.lfWeight = FW_NORMAL;
	if (m_fntScrTxt.GetSafeHandle() == NULL)
	{
		m_fntScrTxt.CreateFontIndirect(&logFont);
	}
	

	logFont.lfUnderline=TRUE;
	if (m_fntUnderlineTxt.GetSafeHandle() == NULL)
	{
		m_fntUnderlineTxt.CreateFontIndirect(&logFont);	
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::DelTxtFrm(BOOL bRePaint)
{
	//  ũ Ÿ̸ 
	SetTimerEvent(FALSE);

	// Ʈ ʱȭ
	if (m_TxtFrmList.empty() == false)
	{
		for (TXTFRMLIST_ITER iter = m_TxtFrmList.begin(); iter != m_TxtFrmList.end(); iter++)
		{
			delete (*iter);
			(*iter) = NULL;
		}
		m_TxtFrmList.clear();
	}


	if (m_ScrTxtList.empty() == false)
		m_ScrTxtList.clear();

	//  
	m_bMsgDispFin = TRUE;
	m_nTxtFrameIdx = -1;

	//  ũ ؽƮ ȿȭ
	if (bRePaint == TRUE)
		Invalidate();
}
//-----------------------------------------------------------------------------
void CScrollStatic::CalcTxtArea(void)
{
	// Static Ʈ 
	GetWindowRect(&m_rectStaticCtrl);

	//-----------------------------------------------------------------------------
	// by cscho
	// ּȭ RECT ȿȭ 
	if (m_rectStaticCtrl.IsRectEmpty())
		return;
	//-----------------------------------------------------------------------------

	// ش  Ŭ̾Ʈ  ȯ
	ScreenToClient(&m_rectStaticCtrl);

	//  Ŭ̾Ʈ  
	m_rectScrolArea = m_rectStaticCtrl;

	//  鿩 ϱ   
	m_rectScrolArea.DeflateRect(2, 2);

	//-----------------------------------------------------------------------------
	// by cscho
	if (m_bMultiText)
	{
		BOOL bModify = CalcScrTxtFrm();
		if (m_pClientDC)
		{
			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
	}
	//-----------------------------------------------------------------------------
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::CalcScrTxtFrm()
{
	if (!m_ScrTxtList.size())
		return FALSE;

	CString strMsg;
	if (m_bMultiText)
	{
		m_nTxtFrameIdx = -1;

		m_ScrTxtList.clear();

		m_bPrevArrowExist = ExistPrevTxtFrm();
		if (m_bPrevArrowExist)
		{
			m_rtPrevArrow.SetRect(m_rectScrolArea.left + 1,
				m_rectScrolArea.top,
				m_rectScrolArea.left + m_szPrevArrow.cx,
				m_rectScrolArea.bottom);
		}

		CSize szPrevArrow = CSize(0, 0);
		if (m_bPrevArrowExist)
			szPrevArrow = m_szPrevArrow;

		int nNewPos = m_rectScrolArea.left;		
		if (m_bPrevArrowExist)
			nNewPos += szPrevArrow.cx;
		else
			nNewPos += 3;

		TXTFRMLIST_ITER iter = m_TxtFrmList.begin();
		for(; iter != m_TxtFrmList.end(); iter++)
		{
			m_nTxtFrameIdx++;

			if (m_nTxtFrameIdx < m_nScrTxtIdxFirst)
				continue;

			CTxtFrm* pTxtFrm = (CTxtFrm*)(*iter);
			if (pTxtFrm)
			{
				strMsg.Format(_T("\nm_nTxtFrameIdx=%d\n"), m_nTxtFrameIdx);
				OutputDebugString(strMsg);

				strMsg.Format(_T("\npTxtFrm->m_strScrolTxt=%s\n"), pTxtFrm->m_strScrolTxt);
				OutputDebugString(strMsg);

				strMsg.Format(_T("\nnNewPos=%d\n"), nNewPos);
				OutputDebugString(strMsg);

				pTxtFrm->m_xOffSetList[0] = nNewPos;
				if (nNewPos < m_rectScrolArea.right)
					m_ScrTxtList.push_back(m_nTxtFrameIdx);

				nNewPos = nNewPos + pTxtFrm->m_sizeTxt.cx + I_MSG_GAP;
			}
		}

		m_bNextArrowExist = ExistNextTxtFrm();
		if (m_bNextArrowExist)
		{
			m_rtNextArrow.SetRect(m_rectScrolArea.right - m_szNextArrow.cx,
				m_rectScrolArea.top,
				m_rectScrolArea.right - 1,
				m_rectScrolArea.bottom);
		}
	}

	return TRUE;
}
//-----------------------------------------------------------------------------
void CScrollStatic::SetScrollNewPos(void)
{	
	int nNewXOffset;

	// ũ  ؽƮ  
	if (!m_TxtFrmList.size()) 
		return;

	//  ũ  ؽƮ
	for (int i = 0; i < (int)m_ScrTxtList.size(); i++)
	{
		// ε شϴ ؽƮ  
		CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[m_ScrTxtList[i]];

		// ɼ ε		
		int nSameItemIdx = GetSameItemIdx(m_ScrTxtList, i);

		// ο ̵ ġ 
		nNewXOffset = pTxtFrm->m_xOffSetList[nSameItemIdx] - I_SCR_PIX;

		// ɼ ġ   ̵
		pTxtFrm->m_xOffSetList[nSameItemIdx] = nNewXOffset;
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::SetClippingRegion(CDC* pClientDC)
{
	if (!pClientDC) 
		return;

	CRgn rgnClientDC;

	// ؽƮ   Ŭ 
	rgnClientDC.CreateRectRgnIndirect(&m_rectScrolArea);

	// Ŭ̾Ʈ DC Ŭ  
	pClientDC->SelectClipRgn(&rgnClientDC);
}
//-----------------------------------------------------------------------------
// by cscho
//     
BOOL CScrollStatic::DrawFixTxt(CDC* pClientDC, BOOL bGoNext)
{

	if (NULL == pClientDC)
	{
		return FALSE;
	}

	CTxtFrm* pTxtFrm = NULL;

	if (m_TxtFrmList.size() > 0)
	{
		if (!m_bMultiText && m_nTxtFrameIdx >= 0)
		{
			m_ScrTxtList.clear();

			pTxtFrm = (CTxtFrm*)m_TxtFrmList[m_nTxtFrameIdx];
			if (pTxtFrm)
			{
				m_ScrTxtList.push_back(m_nTxtFrameIdx);

				CString strTotal = _T("");
				if (!m_strPrefix.IsEmpty())
					strTotal.Format(_T("[%s] %s"), m_strPrefix, pTxtFrm->m_strScrolTxt);
				else
					strTotal.Format(_T("%s"), pTxtFrm->m_strScrolTxt);

				CRect rectScrollTxtArea(m_rectScrolArea.left + 3,
					m_rectScrolArea.top,
					m_rectScrolArea.left + 3 + pTxtFrm->m_sizeTxt.cx + m_szPrefix.cx,
					m_rectScrolArea.bottom);

				if (m_nTxtFrameIdx == m_nOverTxtFrmIdx)
				{
					m_clrPreTxtFrm = I_CLR_BLU;
					pClientDC->SetTextColor(I_CLR_BLU);
				}
				else if (pTxtFrm->m_nDspDiv == 2)
				{
					m_clrPreTxtFrm = I_CLR_BLU;
					pClientDC->SetTextColor(I_CLR_BLU);
				}
				else
				{
					m_clrPreTxtFrm=I_CLR_BLK;
					pClientDC->SetTextColor(I_CLR_BLK);
				}

				pClientDC->DrawText(strTotal, &rectScrollTxtArea, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			}
		}
		else
		{
			CSize szPrevArrow = CSize(0, 0);
			CSize szNextArrow = CSize(0, 0);
			if (m_bPrevArrowExist)
			{
				szPrevArrow = m_szPrevArrow;
				if (m_bHoverPrevArrow)
					pClientDC->SetTextColor(I_CLR_BLU);
				else
					pClientDC->SetTextColor(I_CLR_BLK);
				pClientDC->DrawText(m_strPrevArrow, &m_rtPrevArrow, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			}

			int nTxtFrmIdx = -1;
			for (int i = 0; i < (int)m_ScrTxtList.size(); i++)
			{
				nTxtFrmIdx = m_ScrTxtList[i];
				pTxtFrm = (CTxtFrm*)m_TxtFrmList[nTxtFrmIdx];
				if (pTxtFrm)
				{
					CString strTotal = _T("");
					if (!m_strPrefix.IsEmpty())
						strTotal.Format(_T("[%s] %s"), m_strPrefix, pTxtFrm->m_strScrolTxt);
					else
						strTotal.Format(_T("%s"), pTxtFrm->m_strScrolTxt);

					CRect rectScrollTxtArea(pTxtFrm->m_xOffSetList[0],
						m_rectScrolArea.top,
						pTxtFrm->m_xOffSetList[0] + pTxtFrm->m_sizeTxt.cx + m_szPrefix.cx,
						m_rectScrolArea.bottom);
					if (rectScrollTxtArea.right >= m_rectScrolArea.right)
						rectScrollTxtArea.right = m_rectScrolArea.right - 1;

					if (nTxtFrmIdx == m_nOverTxtFrmIdx)
					{
						m_clrPreTxtFrm = I_CLR_BLU;
						pClientDC->SetTextColor(I_CLR_BLU);
					}
					else if (pTxtFrm->m_nDspDiv == 2)
					{
						m_clrPreTxtFrm = I_CLR_BLU;
						pClientDC->SetTextColor(I_CLR_BLU);
					}
					else
					{
						m_clrPreTxtFrm=I_CLR_BLK;
						pClientDC->SetTextColor(I_CLR_BLK);
					}

					pClientDC->DrawText(strTotal, &rectScrollTxtArea, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
				}
			}

			if (m_bNextArrowExist)
			{
				szNextArrow = m_szNextArrow;
				if (m_bHoverNextArrow)
					pClientDC->SetTextColor(I_CLR_BLU);
				else
					pClientDC->SetTextColor(I_CLR_BLK);
				pClientDC->DrawText(m_strNextArrow, &m_rtNextArrow, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			}
		}
	}

	return TRUE;
}
//-----------------------------------------------------------------------------
void CScrollStatic::DrawScrTxt(CDC* pClientDC)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	if (pClientDC != NULL)
	{
		CFont* pOldFont = NULL;

		for (int i = 0; i < (int)m_ScrTxtList.size(); i++)
		{
			// ũ ؽƮ ؽƮ 
			CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[m_ScrTxtList[i]];

			// ũ 迭   ִ 			
			int nSameItemIdx = GetSameItemIdx(m_ScrTxtList, i);

			// ũ ؽƮ ¿ 簢 (left,top,right,bottom)			
			CRect rectScrollTxtArea(pTxtFrm->m_xOffSetList[nSameItemIdx], 
				m_rectScrolArea.top,
				m_rectScrolArea.right,
				m_rectScrolArea.bottom);

			//  ޽   ȯ
			if (pTxtFrm->m_nDspDiv == 2)
			{
				m_clrPreTxtFrm = I_CLR_BLU;
				pClientDC->SetTextColor(I_CLR_BLU);
			}
			else
			{
				m_clrPreTxtFrm = I_CLR_BLK;
				pClientDC->SetTextColor(I_CLR_BLK);
			}

			pOldFont = pClientDC->SelectObject(&m_fntScrTxt);

			//   ũ  
			pClientDC->DrawText(pTxtFrm->m_strScrolTxt, &rectScrollTxtArea, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			pClientDC->SelectObject(pOldFont);

			// ؽƮ    ȿȭ
			CRect rectNoUseArea(pTxtFrm->m_xOffSetList[nSameItemIdx] + pTxtFrm->m_sizeTxt.cx, 
				m_rectScrolArea.top,
				pTxtFrm->m_xOffSetList[nSameItemIdx] + pTxtFrm->m_sizeTxt.cx+I_SCR_PIX,
				m_rectScrolArea.bottom);
			InvalidateRect(&rectNoUseArea);
		}		
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::AddNewScr(void)
{
	if (m_TxtFrmList.size())
	{
		if (!m_ScrTxtList.size())
			return;

		//  ũ ؽƮ  ε
		int nTxtFrmIdx = m_ScrTxtList[(int)(m_ScrTxtList.size() - 1)];

		//  ؽƮ 		
		CTxtFrm* FinalTxtFrm = (CTxtFrm*)m_TxtFrmList[nTxtFrmIdx];

		//  ũ  ڿ ߰ ڸ   ִ ˻
		if ((FinalTxtFrm->m_xOffSetList[FinalTxtFrm->m_xOffSetList.size() - 1] + FinalTxtFrm->m_sizeTxt.cx + I_MSG_GAP) >= m_rectScrolArea.right)
			return;

		// ߰ ũ ؽƮ  ε ο
		nTxtFrmIdx++;

		// ȯ ϸ nTxtFrmIdx=0 ʱȭ
		if (nTxtFrmIdx >= (int)m_TxtFrmList.size())
			return;

		// ش ؽƮ 
		CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[nTxtFrmIdx];

		// ũ 
		pTxtFrm->m_xOffSetList.push_back(m_rectScrolArea.right);

		// ű ؽƮ  ε ߰
		m_ScrTxtList.push_back(nTxtFrmIdx);
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::DelScrFin(void)
{
	if (m_TxtFrmList.empty() == false && m_ScrTxtList.empty() == false)
	{
		//   ũ  ù° ؽƮ ε		
		int nTxtFrmIdx = m_ScrTxtList[0];		

		// ù° ؽƮ 
		CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[nTxtFrmIdx];

		// ù° ؽƮ  ũ  Ǿ ˻
		if ((pTxtFrm->m_xOffSetList[0] + pTxtFrm->m_sizeTxt.cx) <= m_rectScrolArea.left)
		{
			// ؽƮ  x ɼ° 
			pTxtFrm->m_xOffSetList.erase(pTxtFrm->m_xOffSetList.begin());

			// ũ 迭 ش ؽƮ  
			m_ScrTxtList.erase(m_ScrTxtList.begin());

			// ũѸ 
			if (m_ScrTxtList.empty() == true)
				SetNextDsp();
		}
	}
}
//-----------------------------------------------------------------------------
int CScrollStatic::GetSameItemIdx(SCRTXTIDXLIST& ScrollTxtIdxList, int nArrCheckIdx)
{
	int nSameItemIdx = 0;

	// ũ ؽƮ 迭  ؽƮ ε ϱ	
	int nTxtIdx = ScrollTxtIdxList[nArrCheckIdx];

	// ũ 迭 ̹  Ұ ϸ Ŭ 
	for (int i = 0; i < nArrCheckIdx; i++)
	{
		if (ScrollTxtIdxList[i] == nTxtIdx)
			nSameItemIdx++;
	}

	return nSameItemIdx;
}
//-----------------------------------------------------------------------------
int CScrollStatic::GetHoverTxtFrm(CPoint pntMouseCursor, int* pnXOffSet)
{
	CString strMsg;
	if (pnXOffSet)
	{
		for (int i = 0; i < (int)m_ScrTxtList.size(); i++)
		{
			int nTxtFrmIdx = m_ScrTxtList[i];

			// ؽƮ 
			CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[nTxtFrmIdx];

			// 
			if (m_nHowScrollType)
			{
				for (int x = 0; x < (int)pTxtFrm->m_xOffSetList.size(); x++)
				{
					//  ¿ ġ 					
					int nXLeftOffSet = pTxtFrm->m_xOffSetList[x];					
					int nXRightOffSet = pTxtFrm->m_xOffSetList[x] + pTxtFrm->m_sizeTxt.cx;

					// y  					
					int nYPos = m_rectScrolArea.Height() - pTxtFrm->m_sizeTxt.cy;

					// ũ  
					if(nXLeftOffSet < m_rectScrolArea.left)
						nXLeftOffSet = m_rectScrolArea.left;
					if(nXRightOffSet > m_rectScrolArea.right)
						nXRightOffSet = m_rectScrolArea.right;

					CRect rectScrollTxtArea(nXLeftOffSet,
						nYPos,
						nXRightOffSet,
						nYPos + pTxtFrm->m_sizeTxt.cy);

					// 콺 Ŀ   ִ ˻
					if (rectScrollTxtArea.PtInRect(pntMouseCursor))
					{
						*pnXOffSet = pTxtFrm->m_xOffSetList[x];
						return nTxtFrmIdx;
					}
				}
			}
			else
			{
				// y  
				int nYPos = m_rectScrolArea.Height() - pTxtFrm->m_sizeTxt.cy;

				//-----------------------------------------------------------------------------
				// by cscho
				//  
				CRect rectScrollTxtArea(m_rectScrolArea.left + 3,
					nYPos,
					m_rectScrolArea.left + 3 + pTxtFrm->m_sizeTxt.cx + m_szPrefix.cx,
					nYPos+pTxtFrm->m_sizeTxt.cy);
				if (m_bMultiText)
				{
					rectScrollTxtArea.left = pTxtFrm->m_xOffSetList[0];
					rectScrollTxtArea.right = rectScrollTxtArea.left + pTxtFrm->m_sizeTxt.cx;

					BOOL bLastTxtFrm = CheckLastScrTxtFrm(pTxtFrm);
					if (bLastTxtFrm && m_bNextArrowExist)
					{
						rectScrollTxtArea.right = m_rtNextArrow.left;
					}
				}
				//-----------------------------------------------------------------------------

				//strMsg.Format(_T("rectScrollTxtArea=%d,%d,%d,%d\n"), rectScrollTxtArea.left, rectScrollTxtArea.top, rectScrollTxtArea.right, rectScrollTxtArea.bottom);
				//OutputDebugString(strMsg);

				//strMsg.Format(_T("pntMouseCursor=%d,%d\n"), pntMouseCursor.x, pntMouseCursor.y);
				//OutputDebugString(strMsg);

				// 콺 Ŀ   ִ ˻
				if (rectScrollTxtArea.PtInRect(pntMouseCursor))
				{
					*pnXOffSet = rectScrollTxtArea.left;
					return nTxtFrmIdx;
				}
			}
		}
	}

	return -1;
}
//-----------------------------------------------------------------------------
void CScrollStatic::PreSubclassWindow() 
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	// θ Ŭ  ޼ ް 	
	DWORD nStatusWndStyle = GetStyle();
	SetWindowLong(GetSafeHwnd(), GWL_STYLE, nStatusWndStyle|SS_NOTIFY);

	// ũ ؽƮ Ʈ 
	CreateTxtFont();

	//   ؽƮ  
	CalcTxtArea();

	CStatic::PreSubclassWindow();
}

//-----------------------------------------------------------------------------
// by cscho
//     
BOOL CScrollStatic::OnEraseBkgnd(CDC* pClientDC) 
{
	return TRUE;
}
//-----------------------------------------------------------------------------
// by cscho
//     
void CScrollStatic::OnPaint() 
{	
	CPaintDC dc(this);

	CRect rect(0, 0, 0, 0);
	GetClientRect(&rect);

	int nWidth = rect.Width();
	int nHeight = rect.Height();

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);

	CBitmap bmpMem;
	CBitmap* pOldBmp = NULL;

	CFont* pOldFont = NULL;

	bmpMem.CreateCompatibleBitmap(&dc, nWidth, nHeight);
	pOldBmp = memDC.SelectObject(&bmpMem);
	pOldFont = memDC.SelectObject(&g_ftDefault8PT);

	memDC.FillSolidRect(rect, m_clrBackGround);

	CPen pen, *pOldPen = NULL;
	pen.CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW));
	pOldPen = memDC.SelectObject(&pen);

	memDC.MoveTo(rect.left, rect.top);
	memDC.LineTo(rect.right, rect.top);
	memDC.MoveTo(rect.left, rect.bottom);
	memDC.LineTo(rect.right, rect.bottom);

	DrawFixTxt(&memDC);

	dc.BitBlt(0, 0, nWidth, nHeight, &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
	memDC.SelectObject(pOldBmp);

	bmpMem.DeleteObject();

	memDC.DeleteDC();
}
//-----------------------------------------------------------------------------
void CScrollStatic::OnTimer(UINT nIDEvent)
{
	if (!m_pClientDC) 
	{
		KillTimer(I_EVT_TXT_SCR);
		return;
	}

	if (m_nHowScrollType)
	{
		// ũ ӵ   ũ ؽƮ ̵ ġ 
		SetScrollNewPos();

		// ؽƮ  ũ  
		DrawScrTxt(m_pClientDC);

		// ũ  ؽƮ ε 
		DelScrFin();

		// ο ũ ؽƮ ߰
		AddNewScr();
	}
	else
	{
		//-----------------------------------------------------------------------------
		// by cscho
		//     
		if (m_bMultiText)
			KillTimer(I_EVT_TXT_SCR);
		else
		{
			if ((int)m_nTxtFrameIdx == ((int)m_TxtFrmList.size() - 1))
				m_nTxtFrameIdx = -1;
			m_nTxtFrameIdx++;

			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
		//-----------------------------------------------------------------------------
	}

	CStatic::OnTimer(nIDEvent);
}
//-----------------------------------------------------------------------------
void CScrollStatic::OnSize(UINT nType,int cx,int cy) 
{
	CStatic::OnSize(nType, cx, cy);

	CalcTxtArea();
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::DestroyWindow() 
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	SetTimerEvent(FALSE);

	return CStatic::DestroyWindow();
}
//-----------------------------------------------------------------------------
void CScrollStatic::SetNextDsp() 
{
	// ؽƮ  
	DelTxtFrm();

	::PostMessage(m_pOwnWnd->m_hWnd,UM_SCR_FIN,0,0);
}
//-----------------------------------------------------------------------------
void CScrollStatic::ClickTxtFrm(CWnd* pOwnWnd,int nMsgId) 
{
	CTxtFrm* pTxtFrm = NULL;

	if (m_bMouseOverTxt && m_nOverTxtFrmIdx != -1)
	{
		// ؽƮ 
		pTxtFrm = (CTxtFrm*)m_TxtFrmList[m_nOverTxtFrmIdx];

		// ũ ID
		if (!pTxtFrm->m_strLinkId.IsEmpty())
		{			
			int nItemKind = 0;						
			TCHAR* pszItemNo = pTxtFrm->m_strLinkId.GetBuffer();

			//   
			switch (pszItemNo[0])
			{
				//O:ް, M:, L:ܺθũ
			case 'O': 
				nItemKind = 1; 
				break;
			case 'M': 
				nItemKind = 2;
				break;		
			case 'L':
				nItemKind = 3;
				break;
			default: return;
			}

			//  û ޽ 
			pszItemNo += 2; 			
			int nItemRecNo = _wtoi(pszItemNo);
			//-----------------------------------------------------------------------------
			// by cscho
			::PostMessage(pOwnWnd->m_hWnd, nMsgId, nItemKind, m_nOverTxtFrmIdx);
			//-----------------------------------------------------------------------------

			// 콺  
			m_bMouseOverTxt = FALSE;
			SetTimerEvent(TRUE);
		}
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::GetNextMsg() 
{
	if (m_bMsgDispFin)
		return;

	SetTimerEvent(FALSE);

	//  ؽƮ 
	if (!DrawFixTxt(m_pClientDC, TRUE))
		SetNextDsp();
}
//-----------------------------------------------------------------------------
void CScrollStatic::GetPrevMsg() 
{
	if (m_bMsgDispFin || (m_nTxtFrameIdx == -1))
		return;

	SetTimerEvent(FALSE);

	//  ؽƮ 
	DrawFixTxt(m_pClientDC, FALSE);
}
//-----------------------------------------------------------------------------
void CScrollStatic::SetChangeScrollType(int nHowScrollType, int nScrollSpeed) 
{
	SetTimerEvent(FALSE);

	// ũ ӵ
	m_nScrollTimer = nScrollSpeed;

	//   ľ
	if (m_nHowScrollType != nHowScrollType)
	{
		m_nHowScrollType = nHowScrollType;
		BeginScrolling(m_pOwnWnd);
	}
	else 
	{
		m_nHowScrollType = nHowScrollType;
		SetTimerEvent(TRUE);
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::SetTimerEvent(BOOL bTimerOn) 
{	
	// Ÿ̸ 
	if (bTimerOn)
	{
		if (m_bTimerOn)
			return;		
		//SetTimer(I_EVT_TXT_SCR, m_nScrollTimer, NULL);
		::SetTimer(this->m_hWnd, I_EVT_TXT_SCR, m_nScrollTimer, NULL);
		m_bTimerOn = TRUE;
		OutputDebugString(_T("\r\n##### timer set... #####\r\n"));
	}
	else
	{
		if (!m_bTimerOn) 
			return;
		::KillTimer(this->m_hWnd, I_EVT_TXT_SCR);
		m_bTimerOn = FALSE;
	}

}
//-----------------------------------------------------------------------------
// by cscho
//     
void CScrollStatic::OnMouseMove(UINT nFlags, CPoint point)
{
	int nXOffSet = 0;

	BOOL bHoverPrevArrow = IsHoverPrevArrow(point);
	BOOL bHoverNextArrow = IsHoverNextArrow(point);	

	int nHoverTxtFrmIdx = -1;
	if (!bHoverPrevArrow && !bHoverNextArrow)
		nHoverTxtFrmIdx = GetHoverTxtFrm(point, &nXOffSet);

	m_nOverPreFrmIdx = m_nOverTxtFrmIdx;
	m_nOverTxtFrmIdx = nHoverTxtFrmIdx;

	if (m_nOverTxtFrmIdx != -1)
		m_bMouseOverTxt = TRUE;
	else
		m_bMouseOverTxt = FALSE;

	if (bHoverPrevArrow || bHoverNextArrow || m_nOverTxtFrmIdx != -1)
		SetTimerEvent(FALSE);
	else
		SetTimerEvent(TRUE);

	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	if ((m_bHoverPrevArrow != bHoverPrevArrow) || (m_bHoverNextArrow != bHoverNextArrow) ||
		(m_nOverTxtFrmIdx != m_nOverPreFrmIdx))
	{
		m_bHoverPrevArrow = bHoverPrevArrow;
		m_bHoverNextArrow = bHoverNextArrow;

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CStatic::OnMouseMove(nFlags, point);
}
//-----------------------------------------------------------------------------
// by cscho
//     
void CScrollStatic::OnMouseHover(UINT nFlags, CPoint point)
{
	CStatic::OnMouseHover(nFlags, point);
}
//-----------------------------------------------------------------------------
// by cscho
//     
void CScrollStatic::OnMouseLeave()
{
	m_bTracking = FALSE;

	m_bHoverPrevArrow = FALSE;
	m_bHoverNextArrow = FALSE;
	m_nOverTxtFrmIdx = -1;
	m_bMouseOverTxt = FALSE;

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}
//-----------------------------------------------------------------------------
void CScrollStatic::OnLButtonDown(UINT nFlags, CPoint point)
{
	// ޼ Ŭ
	if (m_bMouseOverTxt && m_nOverTxtFrmIdx != -1) 
	{
		ClickTxtFrm(m_pOwnWnd, UM_NOTIFY);
	}

	CStatic::OnLButtonDown(nFlags, point);
}
//-----------------------------------------------------------------------------
void CScrollStatic::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (m_bNextArrowExist && m_bHoverNextArrow)
	{
		if (m_rtNextArrow.PtInRect(point))
		{
			DoNextTxtFrm();
		}
	}
	else if (m_bPrevArrowExist && m_bHoverPrevArrow)
	{
		if (m_rtPrevArrow.PtInRect(point))
		{
			DoPrevTxtFrm();
		}
	}

	CStatic::OnLButtonUp(nFlags, point);
}
//-----------------------------------------------------------------------------
int CScrollStatic::GetCurMsgIdx(void)
{	
	//int i, nXOffSet, nMsgIdx;
	CPoint pointMouseCursor(0, 0);

	CRect rectWnd(0, 0, 0, 0);
	GetClientRect(&rectWnd);

	for (int i = 0; i < 10; i++)
	{
		int nXOffSet = 0;

		//  10  1о ߰
		pointMouseCursor.x = rectWnd.left + (rectWnd.Width() / 10 * i);
		pointMouseCursor.y = rectWnd.top + (rectWnd.Height() / 2);

		// 콺 ȣ ؽƮ  ε
		int nMsgIdx = GetHoverTxtFrm(pointMouseCursor, &nXOffSet);

		//  ޽ ε
		if (nMsgIdx != -1)
			return nMsgIdx;
	}

	return -1;
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::ExistPrevTxtFrm()
{
	if (m_nScrTxtIdxFirst > 0)
		return TRUE;

	return FALSE;	
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::ExistNextTxtFrm()
{
	if (m_ScrTxtList.empty())
		return FALSE;

	int nLastScrIndex = m_ScrTxtList[m_ScrTxtList.size() - 1];
	int nCntTxtFrm = m_TxtFrmList.size();

	if (nLastScrIndex < (nCntTxtFrm - 1))
		return TRUE;

	CString strMsg;

	CTxtFrm* pTxtFrm = (CTxtFrm*)m_TxtFrmList[nLastScrIndex];
	if (pTxtFrm)
	{
		if ((pTxtFrm->m_xOffSetList[0] + pTxtFrm->m_sizeTxt.cx) > m_rectScrolArea.right)
		{
			return TRUE;
		}
	}

	return FALSE;
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::CheckLastScrTxtFrm(CTxtFrm* pTxtFrm)
{
	if (m_ScrTxtList.empty())
		return FALSE;

	int nLastScrIndex = m_ScrTxtList[m_ScrTxtList.size() - 1];

	CTxtFrm* pTxtFrmLast = (CTxtFrm*)m_TxtFrmList[nLastScrIndex];
	if (pTxtFrmLast == pTxtFrm)
		return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::IsHoverPrevArrow(CPoint pntMouseCursor)
{
	if (m_bPrevArrowExist && m_rtPrevArrow.PtInRect(pntMouseCursor))
		return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------------
BOOL CScrollStatic::IsHoverNextArrow(CPoint pntMouseCursor)
{
	if (m_bNextArrowExist && m_rtNextArrow.PtInRect(pntMouseCursor))
		return TRUE;

	return FALSE;
}
//-----------------------------------------------------------------------------
void CScrollStatic::UpdateHoverPrevArrow(BOOL bHoverPrevArrow)
{
	if (m_bPrevArrowExist && NULL != m_pClientDC)
	{
		CFont* pOldFont = m_pClientDC->SelectObject(&m_fntScrTxt);

		m_bHoverPrevArrow = bHoverPrevArrow;
		if (m_bHoverPrevArrow)
		{		
			m_pClientDC->SetTextColor(m_clrOverTxt);
		}
		else
		{
			m_pClientDC->SetTextColor(m_clrForeTxt);
		}
		m_pClientDC->FillSolidRect(&m_rtPrevArrow, m_clrBackGround);
		m_pClientDC->DrawText(m_strPrevArrow, &m_rtPrevArrow, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);

		m_pClientDC->SelectObject(pOldFont);
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::UpdateHoverNextArrow(BOOL bHoverNextArrow)
{
	if (m_bNextArrowExist && NULL != m_pClientDC)
	{
		CFont* pOldFont = m_pClientDC->SelectObject(&m_fntScrTxt);

		m_bHoverNextArrow = bHoverNextArrow;
		if (m_bHoverNextArrow)
		{		
			m_pClientDC->SetTextColor(m_clrOverTxt);
		}
		else
		{
			m_pClientDC->SetTextColor(m_clrForeTxt);
		}
		m_pClientDC->FillSolidRect(&m_rtNextArrow, m_clrBackGround);
		m_pClientDC->DrawText(m_strNextArrow, &m_rtNextArrow, DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);

		m_pClientDC->SelectObject(pOldFont);
	}
}
//-----------------------------------------------------------------------------
void CScrollStatic::DoPrevTxtFrm()
{
	if (m_nScrTxtIdxFirst <= 0)
		return;

	m_nScrTxtIdxFirst--;

	CalcScrTxtFrm();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}
//-----------------------------------------------------------------------------
void CScrollStatic::DoNextTxtFrm()
{
	int nCntTxtFrm = m_TxtFrmList.size();

	if (m_nScrTxtIdxFirst >= (nCntTxtFrm - 1))
		return;

	m_nScrTxtIdxFirst++;

	CalcScrTxtFrm();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}
//-----------------------------------------------------------------------------
// by cscho
//     
BOOL CScrollStatic::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
    CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	BOOL bHoverPrevArrow = IsHoverPrevArrow(pt);
	BOOL bHoverNextArrow = IsHoverNextArrow(pt);	

	int nXOffSet;
	int nHoverTxtFrmIdx = -1;
	if (!bHoverPrevArrow && !bHoverNextArrow)
		nHoverTxtFrmIdx = GetHoverTxtFrm(pt, &nXOffSet);

	if (nHoverTxtFrmIdx != -1)
	{
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
		return TRUE;
	}

	return CStatic::OnSetCursor(pWnd, nHitTest, message);
}
//-----------------------------------------------------------------------------
CTxtFrm::CTxtFrm(CString strScrolTxt, CString strLinkId, int nDspDiv)
{
	// ڷ ʱȭ
	m_sizeTxt.cy = 0;
	m_sizeTxt.cx = strScrolTxt.GetLength();
	m_strScrolTxt = strScrolTxt;
	m_strLinkId = strLinkId;
	m_nDspDiv = nDspDiv;
	m_xOffSetList.clear();
}
//-----------------------------------------------------------------------------
CTxtFrm::~CTxtFrm()
{
	m_xOffSetList.clear();
}
//-----------------------------------------------------------------------------
